public class CHeapSorter extends ACompareSorter {
    /**
    * Heapifies A from  lo to hi.
    * @param A an array of int.
    * @param lo the low index of A.
    * @param hi the high index of A.
    */
    public CHeapSorter(IOrdered[] A, int lo, int hi) {
        for (int cur = (hi + lo + 1) / 2; cur >= lo; cur--) {
            Heapifier.Singleton.siftDown (A, lo, cur, hi);
        }
    }

    /**
    * Swaps A[lo] with A[hi] and sift A[lo] down to hi - 1.
    * Assumes A satisfy the heap property.
    * @return hi
    */
    public int split(IOrdered[] A, int lo, int hi) {
        IOrdered temp = A[hi];
        A[hi] = A[lo];
        A[lo] = temp;
        Heapifier.Singleton.siftDown (A, lo, lo, hi - 1);
        return hi;
    }

    /**
    * Does nothing, assuming s == hi.
    */
    public void join(IOrdered[] A, int lo, int s, int hi) {
    }
}

